

      dataComet documentation.  (Rev. 7/5/2010) 
      Copyright 2010 databeast, Inc. All Rights Reserved.


/*
	This include file defines the internal result codes used in translating
	user events into actions for the terminal emulator.  Each result code
	is two bytes long, the first byte is the class type, and the second
	is an entry id for that type. 
*/

/* token classes */

#define RSLT_MENUCLASS   0x1F    /* reserve up to RSLT_ASCI for menus */

#define RSLT_DISABLE     '-'     /* disable a token class, "--" indicates capability string follows */

#define RSLT_COMMENT     '"'     /* '!"\nnn' used for placing a comment in a macro, terminated by \000  */

#define RSLT_ASCI        ' '     /*  ascii character */
#define RSLT_ASCI_TRANS  '@'     /* '@' ascii character, translated before adding to the macro queue */
#define RSLT_LCAC        'A'     /*  IBM local action key */
#define RSLT_SETATTR     'a'     /* 'a' IBM set attributes */
#define RSLT_BUFFER      'B'     /* 'B' append to log, edit, screen buffer */
#define RSLT_EMC         'C'     /*  emulator control */
#define RSLT_DELAY       'D'     /* 'D' delay */
#define RSLT_DELAYTICKS  'd'     /* 'd' ticks delay */
#define RSLT_EDIT        'E'     /* 'E' EDIT action */
#define RSLT_FILE        'F'     /* 'F' FILE action */
#define RSLT_FILETRANS   'f'     /* 'f' FILE Transfer action */
#define RSLT_VARSET      'G'		/* 'G' "Get" variable -- set $\nnn from macro string -- "!$\nnn" puts */
#define RSLT_VARCOPY     'g'		/* 'g' "Get" variable -- set $\nnn from selection -- "!$\nnn" puts */
   /* H, I, J */
#define RSLT_LOOP        'L'     /* 'L' LOOP with count argument */
#define RSLT_LOOPBREAK   'l'     /* 'l' LOOP BREAK with level argument */
#define RSLT_KEYMAP      'K'     /* 'k' select keymap # */
#define RSLT_MVCR        'M'     /* 'M' IBM cursor movement key */
#define RSLT_MENUNAME    'm'     /* 'm' execute named menu item in menu \nnn */
#define RSLT_VTG0        'N'     /* 'N' set (national) char set */
#define RSLT_VTG1        'n'     /* 'n' set (national) char set */
	/* O */
#define RSLT_PFKY        'P'     /* 'P' IBM program function key */
#define RSLT_PROCESS     'p'     /* 'p' actions on CSV variables/row selections */
#define RSLT_QUERY       'Q'     /* 'Q' do user query */
#define RSLT_INFORM      'q'     /* 'q' do user notification in 25th line */
#define RSLT_RECORD      'R'     /* 'R' record macro -- "watch me mode" */
#define RSLT_SEL1        'S'     /* 'S' selection Y start */
#define RSLT_SEL2        'T'     /* 'T' selection X start */
#define RSLT_SEL3        'U'     /* 'U' selection Y end */
#define RSLT_SEL4        'V'     /* 'V' selection X end */
#define RSLT_TELNET      't'     /* 't' Telnet commands */
#define RSLT_WINDNAME    'W'     /* 'W' window selection action */
#define RSLT_WIND        'w'     /* 'w' window selection action */
#define RSLT_XCURS       'X'     /* 'X' cursor movement to x loc */
#define RSLT_YCURS       'Y'     /* 'Y' cursor movement to y loc */
#define RSLT_MATCH       'Z'     /* 'Z' delay for input match failure; failure sets RSLT_TESTMACROFAIL */
#define RSLT_MATCHCASE   'z'     /* 'z' additional table entry input match */

#define RSLT_CSV         ''     /* Put CSV or other labelled string; failure sets RSLT_TESTMACROFAIL */
#define RSLT_VAR         '$'     /* '$' -- Put \nnn global string */

#define RSLT_SEARCH           '/'     /* search for a string; failure sets RSLT_TESTMACROFAIL  */
#define RSLT_SELSHIFTLEFT     '<'     /* shift the selection #to the left */
#define RSLT_SELSHIFTRIGHT    '>'	  /* shift the selection #to the right */
#define RSLT_SELLENGTH        '#'	  /* set the selection length */


/* The item values for each class follow below */

/* strings are terminated with a '\000' */

/* RSLT_WINDNAME 'W' entries */

#define WIND_INPUT            '<'   /* make the following string naming a window the input window; failure sets RSLT_TESTMACROFAIL */
#define WIND_OUTPUT           '>'   /* make the following string naming a window the output window; failure sets RSLT_TESTMACROFAIL */
#define WIND_INPUT_RESET      '{'   /* revert to standard input */
#define WIND_OUTPUT_RESET     '}'   /* revert to standard output */
#define WIND_SELECT           'S'   /* make the following string naming a window the top window failure; failure sets RSLT_TESTMACROFAIL */


/* RSLT_ASCI ' ' entries */

/* the entry for the RSLT_ASCI type is the character to send */


/* RSLT_LCAC 'A' entries */

#define BACKSP_BLANK          ' '     /* space */
#define IBM_SHOWATTR          'A'     /* show IBM attribute characters in display */
#define BACKSP_DEL            'B'     /* B */
#define IBM_BASECOLOR         'C'     /* toggle IBM base color display */
#define DEL_CHAR              'D'
#define ERASE_EOF             'E'
#define INSRT                 'I'
#define RESET                 'R'
#define MOUSE_EXEC            'M'
#define IBM_SELECT            'S'
#define IBM_SELECTCURS        's'
#define INPUT_ERASE           'X'
#define INPUT_ERASEALL        'x'
#define IBM_DUPCHAR           'd'


/* RSLT_SETATTR 'a' entries -- set IBM attributes */

#define TIBMDEFAULTCOLOR      'Z'
#define TIBMRED               'R'
#define TIBMGREEN             'G'
#define TIBMYELLOW            'Y'
#define TIBMBLUE              'B'
#define TIBMPINK              'P'
#define TIBMTURQUOISE         'T'
#define TIBMWHITE             'W'

#define TIBMBACKDEFAULTCOLOR  'z'
#define TIBMBACKRED           'r'
#define TIBMBACKGREEN         'g'
#define TIBMBACKYELLOW        'y'
#define TIBMBACKBLUE          'b'
#define TIBMBACKPINK          'p'
#define TIBMBACKTURQUOISE     't'
#define TIBMBACKWHITE         'w'

#define TIBMDEFAULTHIGH       'X'
#define TIBMBLINK             'A'
#define TIBMREVERSE           'S'
#define TIBMUNDERSCORE        'D'

#define TIBMFONT              'F'
#define TIBMFONTOFF           'f'


/* RSLT_EMC 'C' entries */

#define EM_ALTMACRO           'A'     /* set the ALT (mousedown state) modifier bit */
#define EM_NORMMACRO          'a'     /* always set ALT off */
#define EM_SHIELD             'B'     /* expand a "blank" window to be a shield for kiosk */
#define EM_SHIELDPASS         'b'     /* set a password to reenable all items... */
#define EM_CLOSE              'C'     /* Close the emulator session */
#define EM_RTTSHOW            'D'     /* show RTT rather than packet counts */
#define EM_RTTHIDE            'd'     /* hide RTT */
#define EM_EDIT               'E'     /* show the textwindow */
#define EM_TERM               'e'     /* show the emulator */
#define EM_FILLCLOSE          'F'     /* close the copyright/help textwindow */
#define EM_HIDE               'H'     /* don't update the display */
#define EM_INDMODE            'I'     /* draw each char immediately as received */
#define EM_INDMODEOFF         'i'     /* don't draw as received */
#define EM_COLORFUDGE         'K'     /* use Index2Color to speed color mapping */
#define EM_COLORFUDGEOFF      'k'     /* don't */
#define EM_LITERAL            'L'     /* display literals in ASCII emulators */
#define EM_TELNETLITERAL      'l'     /* display telnet literals */
#define EM_METAFY             'M'     /* make ASCII key a meta-key (set top bit) */
#define EM_NOTIFY             'N'     /* post user notification if in background */
#define EM_IBMPASTEPF         'p'     /* set paste pf for 3270 to execute on wrap for paging */
#define EM_RESTORE            'R'     /* restore line 25 */
#define EM_RESETTIMER         'r'     /* reset session timer */
#define EM_SHOW               'S'     /* update the display as usual */
#define EM_SHOWCURPOS         's'     /* display cursor position */
#define EM_TRACKON            'T'     /* cursor tracking on */
#define EM_TRACKOFF           't'     /* cursor tracking off */
#define EM_URL                'U'     /* execute URL string */
#define EM_VTAUTOPRINT        'V'     /* toggle automatic printing */
#define EM_VTAUTOPRINTOFF     'v'     /* automatic printing OFF */
#define EM_WAITCLICK          'W'     /* wait for a click result before handling other macros */
#define EM_MACRO              'X'     /* execute selection as a macro */
#define EM_OUTPUT             '>'     /* pipe string into the emulator */


/* RSLT_LOOP 'L' entries*/

/* DO WHILE loop begin: the entry for this class is the
   number of times to repeat the loop as '\nnn'; a 0 will cause the loop to be skipped,
   a 255 will cause the loop to continue until interrupted by a "Command-.".
*/


/* RSLT_DELAY 'D' entries */

/* the entry is the time in seconds you wish to delay processing tokens as '\nnn' */


/* RSLT_EDIT 'E' entries */

#define ED_SELALL             'A'
#define ED_SELSCREEN          'a'
#define ED_APPEND             'B'
#define ED_APPENDNOCR         'b'
#define ED_COPY               'C'
#define ED_COPYNOCR           'c'
#define ED_GOTO               'G'
#define ED_GOTOMOUSE          'g'
#define ED_LINESELECT         'L'
#define ED_LINESELECTCURS     'l'
#define ED_SENDMACRO          'M'
#define ED_SENDTEXT           'm'
#define ED_SELRESET           'R'
#define ED_STDMODE            'S'
#define ED_APPENDTABLE        's'
#define ED_TABLEMODE          'T'
#define ED_COPYTABLE          't'
#define ED_PASTE              'V'
#define ED_PASTENOTRANS       'v'
#define ED_WORDSELECT         'W'
#define ED_WORDSELECTCURS     'w'
#define ED_WORDSELECTWRAP     'Y'
#define ED_WORDSELECTCURSWRAP 'y'
#define ED_CUT                'X'
#define ED_CLEARSCRAP         'x'


/* RSLT_FILE 'F' entries */

#define RF_APPEND             'A'			/* append window selection to file with dialog; failure sets RSLT_TESTMACROFAIL */
#define RF_APPENDTO           'B'			/* append window selection to file with dialog; failure sets RSLT_TESTMACROFAIL */
#define RF_PRINTDRAFT         'D'
#define RF_PRINTPUSH          'd'
#define RF_FINDER             'f'
#define RF_FINDERCLOSE        'F'
#define RF_PRINTSCREEN        'P'
#define RF_PRINTTEXT          'p'
#define RF_PRINTTEXTSEL       'q'
#define RF_PRINTSCRAP         'Q'
#define RF_PRINTBUF           'R'
#define RF_PRINTASCBUF        'r'
#define RF_SAVE               'S'			/* save window selection to file; failure sets RSLT_TESTMACROFAIL */
#define RF_SAVEAS             'T'			/* save window selection to file with dialog; failure sets RSLT_TESTMACROFAIL */

#define RF_PRINTVT            'V'

   // select volume and open file commands are below
   // open a file using the following string naming a file

#define RF_OPENHELP        'H'            /* open document by name using the dataComet "Help" folder in application bundle */
#define RF_NAME            'N'            /* open document by name using macro default folder */
#define RF_OPENAPPVOL      'O'            /* open document in Application folder */
#define RF_OPENPREFS       'o'            /* open document in User's Preferences folder */
#define RF_OPENDOC         'W'            /* open document in user's dataComet applicationfolder "Documents" folder */
#define RF_OPENDOCPREFS    'w'            /* open document in user's "dataComet Preferences/Documents" folder */
#define RF_OPENSESS        'X'            /* open document in user's dataComet application folder "Sessions" folder */
#define RF_OPENSESSPREFS   'x'            /* open document in user's "dataComet Preferences/Sessions" folder */
#define RF_SETVOL          'Y'            /* set default volume for macro command file opens to decimal numeric volume # */
#define RF_SETDIR          'y'            /* set default directory for macro command file opens to decimal numeric volume # */
#define RF_OPENUSERDIR     'U'            /* open file in user home folder */
#define RF_SETUSERDIR      'u'            /* set macro default folder to user directory to use for subsequent opens */
#define RF_SETVOLSTRING    'v'            /* set macro default folder to string following command */

#define RF_CSVLOAD         ''            /* load CSV data file  (US: Option-4) failure; failure sets RSLT_TESTMACROFAIL */
#define RF_CSVSEPARATOR    ','            /* set the field separator to be used when loading CSV tables; default is ',' */

   // Use RSLT_CSV !\nnn to put values


/* RSLT_CSV '' entries */

// Send data item entries are in the form !\nnn where:
//		\000 sends the name of the file loaded
//		\nnn ... are the strings loaded, by position

/* RSLT_PROCESS !p entries */

#define RSLT_CSVNEXTROW       '+'		/* select next row of CSV values */
#define RSLT_CSVPREVROW       '-'		/* select previous row of CSV values */
#define RSLT_CSVFIRSTROW      '1'		/* select first row of CSV values */
#define RSLT_CSVLASTROW       '$'		/* select last row of CSV values */
#define RSLT_CSVENDBREAKLOOP  'e'		/* test used after !p+ ; if end of values, cancel enclosing loop */
#define RSLT_CSVENDCANCEL     '.'		/* test used after !p+ ; if end of values, cancel all remaining macros */
#define RSLT_TESTMACROFAIL    '?'      /* test whether a macro command, e.g., file open or match string, has 
                                          failed, and aborts the macros currently executing for this session 
                                          if true 
                                          Can be followed by a string, in which case a Cancel Macro query will be performed using 
                                          the string */
#define RSLT_MACROFAILRESET   '/'      /* reset RSLT_TESTMACROFAIL macro command failure flags */


/* RSLT_FILETRANS 'f' entries */

/* args < 32 are run_zmodem = emdp->zmodem args */

#define FT_folder       'F'
#define FT_upload       'U'
#define FT_abort        'x'

#define FT_ASCII        'A'
#define FT_binary       'a'
#define FT_CRLF         'C'
#define FT_noCRLF       'c'
#define FT_protect      'P'
#define FT_overwrite    'p'
#define FT_append       '+'
#define FT_noappend     '-'

#define FT_trace        'T'
#define FT_notrace      't'
#define FT_dump         'D'
#define FT_nodump       'd'


/* RSLT_MVCR 'M' entries (IBM cursor motion) */

#define HOME            '0'
#define BACK_TAB        '<'
#define TAB_FWD         '>'
#define DOWN_ARROW      'D'
#define LEFT_ARROW      'L'
#define NEW_LINE        'N'
#define RIGHT_ARROW     'R'
#define UP_ARROW        'U'


/* RSLT_PFKY 'P' entries (IBM AND VT220 Program Function keys) */

#define IBMSYSREQ      \00

#define PF1            \001
#define PF2            \002
#define PF3            \003
#define PF4            \004
#define PF5            \005
#define PF6            \006
#define PF7            \007
#define PF8            \008
#define PF9            \009
#define PF10           \010
#define PF11           \011
#define PF12           \012
#define PF13           \013
#define PF14           \014
#define PF15           \015
#define PF16           \016
#define PF17           \017
#define PF18           \018
#define PF19           \019
#define PF20           \020
#define PF21           \021
#define PF22           \022
#define PF23           \023
#define PF24           \024
#define PF25           \025
#define PF26           \026
#define PF27           \027
#define PF28           \028
#define PF29           \029
#define PF30           \030
#define PF31           \031
#define PF32           \032
#define PF33           \033
#define PF34           \034
#define PF35           \035
#define PF36           \036

#define PF37           \037
#define PF38           \038
#define PF39           \039
#define PF40           \040
#define PF41           \041
#define PF42           \042
#define PF43           \043
#define PF44           \044
#define PF45           \045
#define PF46           \046
#define PF47           \047
#define PF48           \048

#define PA1            \049
#define PA2            \050
#define PA3            \051
#define IBMATTN        \065
#define CLEAR          \067
#define IBMDETECT      \068
#define ENTER          \069

#define PFSHIFT        \085
#define PFDUBSHIFT     \087

#define ASPF1          \096   /* 5250 PF keys */
#define ASPF2          \097
#define ASPF3          \098
#define ASPF4          \099
#define ASPF5          \100
#define ASPF6          \101
#define ASPF7          \102
#define ASPF8          \103
#define ASPF9          \104
#define ASPF10         \105
#define ASPF11         \106
#define ASPF12         \107

#define VTFIND         \128
#define VTINSERTHERE   \129
#define VTREMOVE       \130
#define VTSELECT       \131
#define VTPREVSCREEN   \132
#define VTNEXTSCREEN   \133

#define VTPF1          \134
#define VTPF2          \135
#define VTPF3          \136
#define VTPF4          \137


/* the entry for the RSLT_YCURS type is the desired row numbered from 0 as \nnn */

/* the entry for the RSLT_XCURS type is the desired column numbered from 0 as \nnn */


/* RSLT_QUERY 'Q' entries -- any two RSLT_QUERY entries bracket the prompt */

#define QUERY_BEEP           'b'
#define QUERY                'Q'
#define QUERY_END            'E'
#define QUERY_CR             'R'
#define QUERY_SILENT         'S'
#define QUERY_MACROCANCEL    'M'		/* cancel macro if Cancel pressed */


/* RSLT_INFORM "!q" entries -- terminated by \000 or another macro command; empty string resets 25th line */
#define INFORM_BEEP		'b'

/* RSLT_RECORD 'R' entries*/

#define RECORD_ALLDATA       'A'
#define RECORD_NODATA        'a'
#define RECORD_BEGIN         'B'
#define RECORD_END           'E'
#define RECORD_PAUSE         'P'
#define RECORD_IBMALLDATA    'I'
#define RECORD_IBMNODATA     'i'


/* the entry for the RSLT_SEL actions is the desired location numbered from 0 as \nnn */


/* RSLT_TELNET 't' entries */

#define TNMYOUTHERE          'A'
#define TNMBREAK             'B'
#define TNMINTERRUPT         'C'
#define TNMABORT             'U'
#define TNMERASECHAR         'x'
#define TNMERASELINE         'X'

#define TNMCRNOMAPON         'M'
#define TNMCRNOMAPOFF        'm'
#define TNMCRTOLFON          'L'
#define TNMCRTOLFOFF         'l'
#define TNMVTNEWLINEON       'N'
#define TNMVTNEWLINEOFF      'n'
#define TNMCRTOCRON          'R'
#define TNMCRTOCROFF         'r'

#define TNMSENDADDR          'a'     /* type telnet address */
#define TNMSENDPASS          'p'     /* type password */
#define TNMSENDUSERNAME      'u'     /* type username */


